library jaguar_generator.swagger.to_swagger;

import 'package:swagger/swagger.dart';
import 'package:jaguar_generator/parser/parser.dart';

import 'package:source_gen_help/source_gen_help.dart';

class ToSwagger {
  final APIDocument _d = new APIDocument();

  final ParsedUpper model;

  ToSwagger(this.model) {
    _convert();
  }

  APIDocument get document => _d;

  void _convert() {
    final paths = <String, APIPath>{};
    model.routes.forEach((ParsedRoute route) {
      String pathStr = route.item.path; //TODO compute full path
      APIPath path = paths[pathStr];
      if (path == null) {
        path = new APIPath();
        paths[pathStr] = path;
      }

      path.path = pathStr;
      //TODO summary
      //TODO description

      route.item.methods.forEach((String meth) {
        APIOperation op = new APIOperation();

        op.method = meth;

        //TODO summary
        //TODO description
        //TODO consumes
        //TODO produces

        //Parse cookie and header parameters
        route.inputs.forEach((ParsedInput inp) {
          if (inp is ParsedInputCookie) {
            APIParameterInlined p = new APIParameterInlined();
            p.name = inp.key;
            p.required = true;
            p.parameterLocation = APIParameterLocation.cookie;
            p.type = APISchemaObject.TypeString;
            op.parameters.add(p);
          } else if (inp is ParsedInputHeader) {
            APIParameterInlined p = new APIParameterInlined();
            p.name = inp.key;
            p.required = true;
            p.parameterLocation = APIParameterLocation.header;
            p.type = APISchemaObject.TypeString;
            op.parameters.add(p);
          }
        });

        //Parse path variables
        route.nonInputParams.forEach((ParameterElementWrap param) {
          APIParameterInlined p = new APIParameterInlined();
          p.name = param.name;
          p.required = true;
          p.parameterLocation = APIParameterLocation.path;
          //TODO p.type = APISchemaObject.TypeString;
          op.parameters.add(p);
        });

        //Parse query parameters
        if (!route.areOptionalParamsPositional) {
          route.optionalParams.forEach((ParameterElementWrap param) {
            APIParameterInlined p = new APIParameterInlined();
            p.name = param.name;
            p.parameterLocation = APIParameterLocation.query;
            //TODO p.type = APISchemaObject.TypeString;
            op.parameters.add(p);
          });
        }

        //TODO security
        //TODO requestBody
        //TODO responses

        path.operations.add(op);
        _d.paths.add(path);
      });
    });
    //TODO
  }
}
